 /**************************************************************************
 *                                                                         *
 *                                 RasTop                                  *
 *                                                                         *
 *                 Molecular Graphics Visualisation Tool                   *
 *                                                                         *
 *                           by Philippe Valadon                           *
 *                 P.O. Box 8064, La Jolla, CA 92192-8064, USA,            *
 *                       www.geneinfinity.org/rastop                       *
 *                                                                         *
 *                                *******                                  *
 *                                                                         *
 *                   Based on RasMol 2.6 by Roger Sayle                    *
 * Biomolecular Structures Group, Glaxo Wellcome Research & Development,   *
 *                      Stevenage, Hertfordshire, UK                       *
 *         Version 2.6, August 1995, Version 2.6.4, December 1998          *
 *                   Copyright (C) Roger Sayle 1992-1999                   *
 *                                                                         *
 *                                 and                                     *
 *                                                                         *
 * Arne Mueller       RasMol 2.6x1   May 1998   (C) Arne Mueller 1998      *
 * Gary Grossman and  RasMol 2.5-ucb Nov 1995   (C) UC Regents/ModularCHEM *
 * Marco Molinaro     RasMol 2.6-ucb Nov 1996       Consortium 1995, 1996  *
 * Herbert J.         RasMol 2.7.0   Mar 1999   (C) Herbert J. Bernstein   * 
 * Bernstein          RasMol 2.7.1   Jun 1999       1998-2001              *
 *                    RasMol 2.7.1.1 Jan 2001                              *
 *                    RasMol 2.7.2   Aug 2000                              *
 *                    RasMol 2.7.2.1 Apr 2001                              *
 * Philippe Valadon   RasTop 2.0.2   Oct 2002   (C) Philippe Valadon       *
 *                                                  2000-2002              *
 *                                                                         *
 * Naoum Salam       RasTop 2.0.1-VF May 2002  (C) Naoum Salam 2002      *
 *                                                                         *
 * Philippe Valadon   RasTop 2.0.3   Jan 2003   (C) Philippe Valadon       *
 *                                                  2000-2003              *
 *                                                                         * 
 * Christian DUQU    RasTop 2.0.3-VF  Oct. 2003  (C) Christian DUQU 2003 *
 *                                                                         *
 * Please read the file NOTICE for important notices which apply to this   *
 * package. If you are not going to make changes to Rasmol, you are not    *
 * only permitted to freely make copies and distribute them, you are       *
 * encouraged to do so, provided you do the following:                     *
 *   * 1. Either include the complete documentation, especially the file   *
 *     NOTICE, with what you distribute or provide a clear indication      *
 *     where people can get a copy of the documentation; and               *
 *   * 2. Please give credit where credit is due citing the version and    *
 *     original authors properly; and                                      *
 *   * 3. Please do not give anyone the impression that the original       *
 *     authors are providing a warranty of any kind.                       *
 *                                                                         *
 * If you would like to use major pieces of Rasmol in some other program,  *
 * make modifications to Rasmol, or in some other way make what a lawyer   *
 * would call a "derived work", you are not only permitted to do so, you   *
 * are encouraged to do so. In addition to the things we discussed above,  *
 * please do the following:                                                *
 *   * 4. Please explain in your documentation how what you did differs    *
 *     from this version of Rasmol; and                                    *
 *   * 5. Please make your modified source code available.                 *
 *                                                                         *
 * This version of Rasmol is not in the public domain, but it is given     *
 * freely to the community in the hopes of advancing science. If you make  *
 * changes, please make them in a responsible manner, and please offer us  *
 * the opportunity to include those changes in future versions of Rasmol.  *
 ***************************************************************************/

////////////////////////////////////////////////////////////////////////////
// EchoFrm.cpp:
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "echofrm.h"
#include "RasTop.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define MAXLIGNES 1000

//////////////////////////////////////////////////////////////////////
// CEchoFrm

IMPLEMENT_DYNAMIC(CEchoFrm, CDialogBar)

BEGIN_MESSAGE_MAP(CEchoFrm, CDialogBar)
	//{{AFX_MSG_MAP(CEchoFrm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CEchoFrm::CEchoFrm()	{}
CEchoFrm::~CEchoFrm()	{}

BOOL CEchoFrm::Create(CWnd * pParentWnd, UINT nIDTemplate, UINT nStyle, UINT nID)
{
	if( !CDialogBar::Create(pParentWnd, nIDTemplate, nStyle, nID) )
		return false;

	SetWindowText(_T("cho"));
	EnableDocking(0);

	m_EchoText.SubclassDlgItem(IDC_ECHOTEXT,this);
	m_EchoText.SetReadOnly(true);

	/*Cre la police de la zone de texte
	de la fentre d'cho*/
	LOGFONT logFont;
	memset(&logFont, 0, sizeof(logFont));
	logFont.lfHeight = -11;
	logFont.lfWeight = FW_NORMAL;
	logFont.lfPitchAndFamily = DEFAULT_PITCH | FF_SWISS;
	_ASSERT( LF_FACESIZE > lstrlen( _T("Arial") ) );
	lstrcpy( logFont.lfFaceName, _T("Arial") );
	m_FontEchoText.CreateFontIndirect( &logFont);
	m_EchoText.SetFont (&m_FontEchoText);

	return true;
}

void CEchoFrm::EcrisDansEcho(CString& strText) 
{	static Compteur = 0;
	CString   strBuffer;
	int i; 

	if( strText.IsEmpty() )	
		return;
	else
	{	i = strText.GetLength();
		if( i>0 )
			if( strText.GetAt(i-1)=='\n' )
				strText = strText.Left(i-1);
	}

	m_EchoText.GetWindowText(strBuffer);
	if ( !strBuffer.IsEmpty() )
		strBuffer += "\r\n";
	strBuffer += strText;
	Compteur++;
	if( Compteur>=MAXLIGNES )
	{	char* ptr = strBuffer.LockBuffer();
		int j = 0;
		i = 0;
		while( i<20 && *ptr )
		{	if( *ptr++ =='\n' )
				i++;
			j++;
		}
		strBuffer.UnlockBuffer();
		if( j>=0 )
		{	Compteur -= i;
			strBuffer = strBuffer.Right(strBuffer.GetLength()-j-1);
		}
	}
	m_EchoText.SetWindowText(strBuffer);
	m_EchoText.LineScroll(m_EchoText.GetLineCount(),0);
}
